#include <stdio.h>
#include <math.h>

#define NN 30

float a[NN];
float r;

float pow_2(float f, int n){
  unsigned long l;
  unsigned long e;
  
  l = *(unsigned long *)&f;
  e = (l & 0x7F800000UL) >> 23;
  e = (e + n) & 0xFF;
  l = l & 0x807FFFFF | (e << 23);
  return *(float *)&l;
}

void init(){
  int i;
  float f;
  
  r = 1.0;
  for(i = 0; i < NN; i++){
    a[i] = atan(pow_2(1.0, -i));
    r *= cos(a[i]);
    f = 2 * a[i];
  }
  f = 2 * r;
}

float cordic_sin_cos(int type, float theta){
  int i;
  float x, y, z, tmp;
  
  x = r;
  y = 0.0;
  z = 0.0;
  
  for(i = 0; i < NN; i++){
    if(z < theta){
      tmp = x - pow_2(y, -i);
      y = pow_2(x, -i) + y;
      x = tmp;
      z += a[i];
    }else{
      tmp = x + pow_2(y, -i);
      y = -pow_2(x, -i) + y;
      x = tmp;
      z -= a[i];
    }
    printf("x=%e, y=%e, z=%e\n", x, y, z);
  }
  
  return type ? x : y;
}

float cordic_atan(float t){
  int i;
  float x, y, z, tmp;
  
  x = 1.0;
  y = t;
  z = 0.0;
  for(i = 0; i < NN; i++){
    if(y > 0){
      tmp = x + pow_2(y, -i);
      y = -pow_2(x, -i) + y;
      x = tmp;
      z += a[i];
    }else if(y == 0)
      break;
    else{
      tmp = x - pow_2(y, -i);
      y = pow_2(x, -i) + y;
      x = tmp;
      z -= a[i];
    }
    printf("x=%e, y=%e, z=%e\n", x, y, z);
  }
  
  return z;
}

float m_sin(float x){
  while(M_PI < x) x -= 2 * M_PI;
  if(x < 0) return -m_sin(-x);
  if(M_PI / 2 < x) x = M_PI - x;
  if(M_PI / 4 < x)
    return cordic_sin_cos(1, M_PI / 2 - x);
  else
    return cordic_sin_cos(0, x);
}

float m_cos(float x){
  while(M_PI < x) x-= 2 * M_PI;
  if(x < 0) x = -x;
  if(M_PI / 2 < x) return -m_cos(M_PI - x);
  if(M_PI / 4 < x)
    return cordic_sin_cos(0, M_PI / 2 -x);
  else
    return cordic_sin_cos(1, x);
}

int main(){
  int i;
  float f;
  init();
  
  printf("%e %e\n", cordic_atan(12), atan(12));
}
