	addi r1 r0 1
	sll r1 r1 18
	sll r2 r1 1
	jump min_caml_start

min_caml_atan:
	addi r4 r3 0			# y = t
	addi r3 r0 0x4000		# x = 1.0
	sll r3 r3 16
	addi r5 r0 0			# z = 0.0
	addi r6 r0 0			# i = 0
	addi r7 r0 hi(min_caml_cordic_args)	# r7 <- args
	sll r7 r7 16
	addi r7 r7 lo(min_caml_cordic_args)
min_caml_atan_loop:
	srr r8 r3 23			# r8 <- pow_2(x, -i)
	sll r8 r8 23
	sub r9 r3 r8
	srr r8 r8 23
	sub r8 r8 r6
	sll r8 r8 23
	add r8 r8 r9
	srr r9 r4 23			# r9 <- pow_2(y, -i)
	sll r9 r9 23
	sub r10 r4 r9
	srr r9 r9 23
	sub r9 r9 r6
	sll r9 r9 23
	add r9 r9 r10
	add r10 r7 r6			# r10 <- arg + i
	load r10 r10 0			# r10 <- arg[i]
	fbl r4 r0 min_caml_atan_loop_b1		# if y < 0 then goto b1
	fbl r0 r4 min_caml_atan_loop_b2		# if 0 < y then goto b2
	addi r3 r5 0				# if y = 0 then return z
	jr r31
min_caml_atan_loop_b1:
	fsub r3 r3 r9
	fadd r4 r4 r8
	fsub r5 r5 r10
	jump min_caml_atan_loop_end
min_caml_atan_loop_b2:
	fadd r3 r3 r9
	fsub r4 r4 r8
	fadd r5 r5 r10
min_caml_atan_loop_end:
	addi r6 r6 1
	addi r8 r0 20
	bl r6 r8 min_caml_atan_loop
	addi r3 r5 0
	jr r31

min_caml_cos:
	addi r8 r0 0
	jump min_caml_sin_cos
min_caml_sin:
	addi r8 r0 1

min_caml_sin_cos:
	addi r4 r0 0x40C9	# r4 <- pi
	sll r4 r4 16
	addi r4 r4 0x0FDB
	addi r5 r0 0x4149	# r5 <- 2 * pi	
	sll r5 r5 16
	addi r5 r5 0x0FDB
	addi r6 r0 0x4049	# r6 <- pi / 2
	sll r6 r6 16
	addi r6 r6 0x0FDB
	addi r7 r0 0x3FC9	# r7 <- pi / 4
	sll r7 r7 16
	addi r7 r7 0x0FDB
min_caml_sin_cos_loop:
	fbl r4 r3 min_caml_sin_cos_loop_b1	#if pi < x then goto b1
	bl r0 r8 min_caml_sin_init		#if r8 then goto sin
	jump min_caml_cos_init
min_caml_sin_cos_loop_b1:
	fsub r3 r3 r5
	jump min_caml_sin_cos_loop

min_caml_cos_init:
	fbl r3 r0 min_caml_cos_b1		# if x < 0 then goto b1
	fbl r6 r3 min_caml_cos_b2		# if pi/2 < x then goto b2
	fbl r7 r3 min_caml_cos_b3		# if pi/4 < x then goto b3
	jump min_caml_cordic_cos
min_caml_cos_b1:
	fsub r3 r0 r3				# x = -x
	jump min_caml_sin_cos_loop
min_caml_cos_b2:			# return -cos(pi - x)
	fsub r3 r4 r3			# x = pi - x
	store r31 r1 0
	addi r1 r1 1
	jal min_caml_cos_init
	subi r1 r1 1
	load r31 r1 0
	fsub r3 r0 r3
	jr r31
min_caml_cos_b3:			# return sin(pi/2 - x)
	fsub r3 r6 r3			# x = pi/2 - x
	jump min_caml_cordic_sin
	
min_caml_sin_init:
	fbl r3 r0 min_caml_sin_b1	# if x < 0 then goto b1
	fbl r3 r6 min_caml_sin_b2	# if x < pi/2 then goto b2
	fsub r3 r4 r3			# x = pi - x
min_caml_sin_b2:
	fbl r7 r3 min_caml_sin_b3	# if pi/4 < x then goto b3
	jump min_caml_cordic_sin	# return cordic_sin(x)
min_caml_sin_b1:
	fsub r3 r0 r3			# return -sin(-x)
	store r31 r1 0
	addi r1 r1 1
	jal min_caml_sin_cos_loop
	subi r1 r1 1
	load r31 r1 0
	fsub r3 r0 r3
	jr r31
min_caml_sin_b3:
	fsub r3 r6 r3			# return cos(pi/2 - x)
	jump min_caml_cordic_cos

min_caml_cordic_sin:
	store r31 r1 0
	addi r1 r1 1
	jal min_caml_cordic_loop_init
	subi r1 r1 1
	load r31 r1 0
	addi r3 r4 0
	jr r31
min_caml_cordic_cos:
	jump min_caml_cordic_loop_init
min_caml_cordic_loop_init:
	add r7 r3 r0			# r7 <- theta
	addi r3 r0 0x3F9B		# x = 0.607253
	sll r3 r3 16
	addi r3 r3 0x74EE
	addi r4 r0 0			# y = 0
	addi r5 r0 0			# z = 0
	addi r6 r0 0			# i = 0
	addi r8 r0 hi(min_caml_cordic_args)	# r8 <- args
	sll r8 r8 16
	addi r8 r8 lo(min_caml_cordic_args)
min_caml_cordic_loop:
	srr r9 r3 23			# r9 <- pow_2(x, -i)
	sll r9 r9 23
	sub r10 r3 r9
	srr r9 r9 23
	sub r9 r9 r6
	sll r9 r9 23
	add r9 r9 r10
	srr r10 r4 23			# r10 <- pow_2(y, -i)
	sll r10 r10 23
	sub r11 r4 r10
	srr r10 r10 23
	sub r10 r10 r6
	sll r10 r10 23
	add r10 r10 r11
	add r11 r8 r6			# r11 <- arg + i
	load r11 r11 0			# r11 <- arg[i]
	fbl r5 r7 min_caml_cordic_loop_b1	# if z < theta then goto b1
	fadd r3 r3 r10
	fsub r4 r4 r9
	fsub r5 r5 r11				# z -= arg[i]
	jump min_caml_cordic_loop_end
min_caml_cordic_loop_b1:
	fsub r3 r3 r10
	fadd r4 r4 r9
	fadd r5 r5 r11
min_caml_cordic_loop_end:
	addi r6 r6 1
	addi r9 r0 20
	bl r6 r9 min_caml_cordic_loop
	jr r31
min_caml_cordic_args:
	.word 0x3FC90FDB
	.word 0x3F6D6338
	.word 0x3EFADBB0
	.word 0x3E7EADD5
	.word 0x3DFFAADE
	.word 0x3D7FEAAE
	.word 0x3CFFFAAB
	.word 0x3C7FFEAB
	.word 0x3BFFFFAB
	.word 0x3B7FFFEB
	.word 0x3AFFFFFB
	.word 0x3A7FFFFF
	.word 0x3A000000
	.word 0x39800000
	.word 0x39000000
	.word 0x38800000
	.word 0x38000000
	.word 0x37800000
	.word 0x37000000
	.word 0x36800000
	.word 0x36000000
	.word 0x35800000
	.word 0x35000000
	.word 0x34800000
	.word 0x34000000
	.word 0x33800000
	.word 0x33000000
	.word 0x32800000
	.word 0x32000000
	.word 0x31800000
